Description
-----------
This module allows the users to select taxonomy terms ("tags") by just clicking on them rather than typing them or selecting them from a dropdown/checkbox list.  It shows them a list of tags, sorted by popularity (defined as how many nodes are tagged with it), up to a configurable maximum number.

This helps the user see what the most commonly used tags on the site are, rather than having to guess. It also avoids creation of numerous closely related and/or similar tags since the user can see such a tag if it already exists. The fact that the tag is only a click away, encourages users to coalesce around a tighter vocabulary than one would have in the absence of this module.

**Note:**
The module works with the "tags style" autocomplete widget from the taxonomy module as well as the [Autocomplete Deluxe](https://www.drupal.org/project/autocomplete_deluxe) module. If you'd like it to be compatible with another module open a request in the issue queue.

Requirements
------------
- Drupal 9.x or 10.x
- Taxonomy module (core)

##Installation & Usage
See the screenshots for usage examples.

To use the module, do the following:

1. Download the module using composer (ex: composer require drupal/popular_tags)
    * Visit https://www.drupal.org/node/1897420 for further information

2. Login as an administrator and enable the module on the "Extend" page.

3. Visit the "Manage form display" page for the content type you wish to use this on (`/admin/structure/types/manage/<content-type>/form-display`).

4.  Click on the ⚙️ (gear) icon next to the taxonomy term field and check the "Use Clickable Popular Tags?" checkbox inside the "Popular Tags" fieldset.

5. Now create or edit a node of that content type. Right under the term reference field you configured you'll see a list of clickable popular tags (provided that some terms do exist).

That's it. Now whenever you edit a node of that content type, you will have the most popular tags listed for you.

Maintainers
-----------
- Jitesh Doshi (https://www.drupal.org/u/jitesh-doshi)
- Christian Crawford (https://www.drupal.org/u/ccrawford91)
- Brooke Heaton (https://www.drupal.org/u/brooke_heaton)