(function ($, Drupal, drupalSettings) {

  Drupal.behaviors.popular_tags = {
    attach: function (context, settings) {
      once('popular_tags_item', '.popular-tags .tag-terms .term', context).forEach(elem => {
        $(elem).on('click', function() {
          const parent = $(this).parents('.field--type-entity-reference');
          if (parent.find('.autocomplete-deluxe-container').length > 0) {
            const input_container = parent.find('.autocomplete-deluxe-container');
            const input = $(this).parents('.autocomplete-deluxe-value-container').find('input:text');
            const current_val = input.val();
            const new_term = $(this).text();
            // Create an array of "terms" from the input's value.
            const terms = current_val.split('"').filter(term => term.trim());
            // If term already exists in the list, do nothing.
            if (terms.includes(new_term)) {
              return false;
            }
            // If field not empty.
            if (current_val.replaceAll('"', '')) {
              $(input).val(current_val + ` ""${new_term}""`);
            } else {
              $(input).val(`""${new_term}""`);
            }
            let new_item_elem = $('<span>').addClass('autocomplete-deluxe-item');
            $(new_item_elem).append(new_term).append('<a href="javascript:void(0);" class="autocomplete-deluxe-item-delete"></a>');
            $('a', new_item_elem).on('mousedown', function() {
              const new_value = input.val().replace(`""${new_term}""`, '').trim()
              $(new_item_elem).parent().next().find('.autocomplete-deluxe-value-field').val(new_value);
              $(new_item_elem).remove();
            });
            if ($('.autocomplete-deluxe-item', input_container).length) {
              new_item_elem.insertAfter($('.autocomplete-deluxe-item', input_container).last());
            } else {
              $(input_container).prepend(new_item_elem);
            }
            return false;
          } else {
            const inp = parent.find('input:text.form-autocomplete');
            const val = inp.val();
            const term = $(this).text();
            const tid = $(this).data('tid');
            if (val.indexOf(term) == 0) {
              return false;
            }
            if (val.indexOf(', ' + term) >= 0) {
              return false;
            }
            if (val) {
              inp.val(`${val}, ${term} (${tid})`);
            } else {
              inp.val(`${term} (${tid})`);
            }
            return false;
          }
        });
      });
      if (drupalSettings.popular_tags) {
        for (field_name in drupalSettings.popular_tags) {
          const _field_name = field_name.replace('_', '-');
          const field_container = $('.form-item--' + _field_name + '-target-id', context);
          const tag_container = field_container.find('.popular-tags');
          const show = tag_container.find('a.show-all-terms');
          const hide = tag_container.find('a.show-popular-terms');
          show.click({
            hide: hide,
            tag_container: tag_container
          }, function (ev) {
            $(this).hide();
            ev.data.hide.show();
            ev.data.tag_container.find('.term').not('.popular').show();
            return false;
          });
          hide.click({
            show: show,
            tag_container: tag_container
          }, function (ev) {
            $(this).hide();
            ev.data.show.show();
            ev.data.tag_container.find('.term').not('.popular').hide();
            return false;
          });
          hide.click();
        }
      }
    }
  }

})(jQuery, Drupal, drupalSettings);